﻿
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using static JSONStorableDynamic;

namespace AwasAutoJuice {
    internal class AwasFluidClothingService {
        private Dictionary<string, AwasFluidCloth> fluidClothes = new Dictionary<string, AwasFluidCloth>();
        private Atom containingAtom;
        private bool allClothesLoaded = false;
        private bool allClothesReady = false;

        public AwasFluidClothingService(Atom atom, bool isFemale) {
            containingAtom = atom;
            if (isFemale) {
                SuperController.singleton.StartCoroutine(LoadFemaleClothing());
            } else {
                SuperController.singleton.StartCoroutine(LoadMaleClothing());
            }
        }

        public bool IsAllClothingReady() {
            return allClothesReady;
        }

        #region Cloth getters
        public AwasFluidCloth GetAwasFluidCloth(string name) {
            return fluidClothes[name];
        }

        public AwasFluidCloth GetPenisWetCloth() {
            return fluidClothes["fluids.static.2.1"];
        }

        public AwasFluidCloth GetPenisCumCloth() {
            return fluidClothes["fluids.static.1.1"];
        }

        public AwasFluidCloth GetWetPenisTipCloth() {
            return fluidClothes["fluids.static.3.1"];
        }

        int jizzQueuePos = 0;
        public AwasFluidCloth GetEjaculateCloth() {
            string[] jizzItems = new string[] { "fluids.detatch.1.1", "fluids.detatch.1.2", "fluids.detatch.1.3" };
            AwasFluidCloth cloth = fluidClothes[jizzItems[jizzQueuePos]];
            jizzQueuePos = (jizzQueuePos + 1) % jizzItems.Length;
            //jizzQueuePos = jizzQueuePos == jizzItems.Length - 1 ? 0 : jizzQueuePos + 1;
            return cloth; 
        }

        bool dripCycle = false;
        public AwasFluidCloth GetPussyDripCloth() {
            string drip = dripCycle ? "fluids.pussy.drip" : "fluids.pussy.drip.1";
            dripCycle = !dripCycle;
            return fluidClothes[drip];
        }

        public AwasFluidCloth GetWetJuicyPussyCloth() {
            return fluidClothes["fluids.pussy.pre.drip"];
        }

        public AwasFluidCloth GetPussyFullOfCumCloth() {
            return fluidClothes["fluids.pussy.pre.drip.1"];
        }

        public AwasFluidCloth GetWetPussyCloth() {
            return fluidClothes["fluids.pussy.wet"];
        }

        public AwasFluidCloth GetMouthCumCorners() {
            return fluidClothes["fluids.mouth.detach.2"];
        }

        public AwasFluidCloth GetMouthCumCornersSticky() {
            return fluidClothes["fluids.mouth.detach.3"];
        }

        public AwasFluidCloth GetMouthCumInMouth() {
            return fluidClothes["fluids.in.mouth.cum"];
        }

        public AwasFluidCloth GetNeckCum() {
            return fluidClothes["fluids.neck.1"];
        }
        #endregion

        private IEnumerator LoadFemaleClothing() {
            List<string> clothesToLoad = new List<string> {
                "fluids.pussy.wet",
                "fluids.pussy.pre.drip",
                "fluids.pussy.pre.drip.1",
                "fluids.pussy.drip",
                "fluids.pussy.drip.1",
                "fluids.in.mouth.cum",
                "fluids.mouth.detach.2",
                "fluids.mouth.detach.3",
                "fluids.neck.1"
            };

            string geometryTransformPath = "rescale2/geometry/FemaleClothes";
            yield return LoadClothing(clothesToLoad, geometryTransformPath);
        }

        private IEnumerator LoadMaleClothing() {
            List<string> maleClothesToLoad = new List<string> {
                "fluids.detatch.1.1",
                "fluids.detatch.1.2",
                "fluids.detatch.1.3",
                "fluids.static.1.1",
                "fluids.static.2.1",
                "fluids.static.3.1"
            };

            string geometryTransformPath = "rescale2/geometry/MaleClothes";
            yield return LoadClothing(maleClothesToLoad, geometryTransformPath);
        }

        private IEnumerator LoadClothing(List<string> clothesToLoad, string geometryTransformPath) {
            do {
                foreach (Transform child in containingAtom.gameObject.transform.Find(geometryTransformPath)) {
                    DAZClothingItem clothItem = child.GetComponentInChildren<DAZClothingItem>(true);
                    if (clothItem != null && clothesToLoad.Contains(clothItem.displayName) && clothItem.uid.Contains(clothItem.displayName)) {
                        if (child.gameObject.activeSelf) {
                            clothesToLoad.Remove(clothItem.displayName);
                            StoreAndPrepClothItem(clothItem);
                        } else {
                            child.gameObject.SetActive(true);
                            clothItem.active = false;
                            OnLoaded OnClothLoaded = null;
                            OnClothLoaded = () => {
                                try {
                                    clothesToLoad.Remove(clothItem.displayName);
                                    StoreAndPrepClothItem(clothItem);
                                } catch (Exception e) {
                                    SuperController.LogError($"Problem loading cloth item {clothItem.name} with {e.Message}");
                                } finally {
                                    clothItem.onLoadedHandlers -= OnClothLoaded;
                                }
                            };
                            clothItem.onLoadedHandlers += OnClothLoaded;
                        }
                    }
                }
                allClothesLoaded = clothesToLoad.Count == 0;
                yield return new WaitForSeconds(0.1f);
                Logger.Debug($"All clothes loaded {allClothesLoaded}");
            } while (!allClothesLoaded);
            allClothesReady = true;
        }

        private void StoreAndPrepClothItem(DAZClothingItem clothItem) {
            AwasFluidCloth fluidCloth = new AwasFluidCloth(clothItem);
            fluidClothes.Add(fluidCloth.name, fluidCloth);
            SetupFluidClothItem(fluidCloth);
            Logger.Debug($"Created and stored {fluidCloth.name}");
        }

        private void SetupFluidClothItem(AwasFluidCloth fluidCloth) {
            fluidCloth.SetAlpha(-1f);
            fluidCloth.SetSimEnabled(true);
            fluidCloth.SetActive(false);
            fluidCloth.SetClothActive(false);
        }
    }
}
